/*----------------------------------------------------------

	DirectX8HvO~O
		DirectInputTv
			Sample004

		utH[XtB[hobNEWCXeBbŃv

	DInput004.cppiCŁj

	2001 NARITA, Takuro. E-Mail narita@a1.mbn.or.jp
--------------------------------------------------------------*/

#define STRICT
#include <windows.h>

#include <dinput.h>
#include <dxerr8.h>

#define RELEASE(x)	{if(x){(x)->Release();x=NULL;}}

/*-------------------------------------------
	Oϐ
--------------------------------------------*/
// AvP[V
HINSTANCE hInstApp;								// CX^XEnh
HWND hwndApp;									// EChEEnh
char szAppName[] = "DirectInput Sample 4";		// AvP[V
bool g_bActive = true;							// EChẼANeBu

// DirectInput̕ϐ
LPDIRECTINPUT8 g_pDInput = NULL;					// DirectInput
LPDIRECTINPUTDEVICE8 g_pDIDevice = NULL;			// DirectInputfoCX
LPDIRECTINPUTEFFECT g_pDIEffect = NULL;				// GtFNg
DIDEVCAPS g_diDevCaps;								// WCXeBbN̔\
#define DIDEVICE_BUFFERSIZE	100						// foCXɐݒ肷obt@ETCY

// bZ[W֐̒`
LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,UINT wParam,LONG lParam);

/*-------------------------------------------
	AvP[V
--------------------------------------------*/
bool InitApp(HINSTANCE hInst,int nCmdShow)
{
	hInstApp=hInst;

	// EChEENX̓o^
	WNDCLASS wndclass;
	wndclass.hCursor		= LoadCursor(NULL,IDC_ARROW);
	wndclass.hIcon			= NULL;
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= szAppName;
	wndclass.hbrBackground	= (HBRUSH)(COLOR_WINDOW + 1);
	wndclass.hInstance		= hInst;
	wndclass.style			= CS_BYTEALIGNCLIENT|CS_VREDRAW|CS_HREDRAW;
	wndclass.lpfnWndProc	= (WNDPROC)MainWndProc;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;

	if(!RegisterClass(&wndclass))
		return false;

	// CEEChE
	hwndApp = CreateWindowEx(0,szAppName,szAppName,
							WS_OVERLAPPEDWINDOW,
							CW_USEDEFAULT,CW_USEDEFAULT,640,480,
							(HWND)NULL,(HMENU)NULL,
							hInst,(LPSTR)NULL);
	ShowWindow(hwndApp,nCmdShow);
	UpdateWindow(hwndApp);

	return true;
}

/*-------------------------------------------
	DirectInput 
---------------------------------------------*/
BOOL CALLBACK EnumJoysticksCallback(const DIDEVICEINSTANCE* pdidInstance, VOID* pContext);
BOOL CALLBACK EnumAxesCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi, LPVOID pvRef);

bool InitDInput(void)
{
	HRESULT hr;

	// *****************************************
	// DirectInput̍쐬
	hr = DirectInput8Create(hInstApp, DIRECTINPUT_VERSION, 
							IID_IDirectInput8, (void**)&g_pDInput, NULL); 
	if (FAILED(hr)) 
	{
		DXTRACE_ERR("DirectInput8IuWFNg̍쐬Ɏs", hr);
		return false;
	}

	// foCX񋓂č쐬
	hr = g_pDInput->EnumDevices(DI8DEVCLASS_GAMECTRL, EnumJoysticksCallback,
							NULL, DIEDFL_FORCEFEEDBACK | DIEDFL_ATTACHEDONLY);
	if (FAILED(hr) || g_pDIDevice==NULL)
	{
		DXTRACE_ERR("DirectInputDevice8IuWFNg̍쐬ɎsBtH[XtB[hobÑWCXeBbNtȂ", hr);
		return false;
	}
 
	// f[^`ݒ
	hr = g_pDIDevice->SetDataFormat(&c_dfDIJoystick2);
	if (FAILED(hr))
	{
		DXTRACE_ERR("c_dfDIJoystick2`̐ݒɎs", hr);
		return false;
	}

	//[hݒitHAOEhr[hj
	hr = g_pDIDevice->SetCooperativeLevel(hwndApp, DISCL_EXCLUSIVE | DISCL_FOREGROUND);
	if (FAILED(hr))
	{
		DXTRACE_ERR("tHAOEhr[h̐ݒɎs", hr);
		return false;
	}

	// Z^O𖳌ɂ
	DIPROPDWORD DIPropAutoCenter;
	DIPropAutoCenter.diph.dwSize       = sizeof(DIPropAutoCenter);
	DIPropAutoCenter.diph.dwHeaderSize = sizeof(DIPROPHEADER);
	DIPropAutoCenter.diph.dwObj        = 0;
	DIPropAutoCenter.diph.dwHow        = DIPH_DEVICE;
	DIPropAutoCenter.dwData            = DIPROPAUTOCENTER_OFF;

	hr = g_pDIDevice->SetProperty(DIPROP_AUTOCENTER, &DIPropAutoCenter.diph);
	if (FAILED(hr))
	{
		DXTRACE_ERR("Z^O̐ݒɎs", hr);
		return false;
	}

	// R[obN֐gĊẽ[hݒ
	hr = g_pDIDevice->EnumObjects(EnumAxesCallback, NULL, DIDFT_AXIS);
	if (FAILED(hr))
	{
		DXTRACE_ERR("[h̐ݒɎs", hr);
		return false;
	}

	// [hݒiΒl[hɐݒBftHgȂ̂ŕKݒ͕KvȂj
	DIPROPDWORD diprop;
	diprop.diph.dwSize	= sizeof(diprop); 
	diprop.diph.dwHeaderSize	= sizeof(diprop.diph); 
	diprop.diph.dwObj	= 0;
	diprop.diph.dwHow	= DIPH_DEVICE;
	diprop.dwData		= DIPROPAXISMODE_ABS;
//	diprop.dwData		= DIPROPAXISMODE_REL;	// Βl[h̏ꍇ
	hr = g_pDIDevice->SetProperty(DIPROP_AXISMODE, &diprop.diph);
	if (FAILED(hr))
	{
		DXTRACE_ERR("[h̐ݒɎs", hr);
		return false;
	}

	// obt@OEf[^擾邽߁Aobt@ETCYݒ
	diprop.dwData = DIDEVICE_BUFFERSIZE;
	hr = g_pDIDevice->SetProperty(DIPROP_BUFFERSIZE, &diprop.diph);
	if (FAILED(hr))
	{
		DXTRACE_ERR("obt@ETCY̐ݒɎs", hr);
		return false;
	}

	// ͐Jn
	g_pDIDevice->Acquire();

	// {^OƎsGtFNgEIuWFNg쐬
	DWORD      dwAxes[2] = { DIJOFS_X, DIJOFS_Y };
	LONG       lDirection[2] = { 0, 0 };

	DIPERIODIC diPeriodic;	// IGtFNg̐ݒp\
	DIENVELOPE diEnvelope;	// Gx[uݒp\
	DIEFFECT   diEffect;	// GtFNgݒp\

	diPeriodic.dwMagnitude = DI_FFNOMINALMAX;	// }Oj`[h͍ő
	diPeriodic.lOffset = 0;
	diPeriodic.dwPhase = 0;
	diPeriodic.dwPeriod = (DWORD)(0.05 * DI_SECONDS); 	// ͂P^20bԊu

	diEnvelope.dwSize = sizeof(DIENVELOPE);
	diEnvelope.dwAttackLevel = 0;	// ŏ̓xE[
	diEnvelope.dwAttackTime = (DWORD)(0.5 * DI_SECONDS);	// A^bNE^C0.5b
	diEnvelope.dwFadeLevel = 0;	// Ō̃x[
	diEnvelope.dwFadeTime = (DWORD)(1.0 * DI_SECONDS);	// tF[hE^C͂Pb

	diEffect.dwSize = sizeof(DIEFFECT); 
	diEffect.dwFlags = DIEFF_POLAR | DIEFF_OBJECTOFFSETS;	// GtFNg͎IGtFNg
	diEffect.dwDuration = (DWORD)(2 * DI_SECONDS);	// GtFNǧpԂ͂Qb
 
	diEffect.dwSamplePeriod = 0;
	diEffect.dwGain = DI_FFNOMINALMAX;	// XP[OȂ
	diEffect.dwTriggerButton = DIJOFS_BUTTON0;	// {^OgK[Ɏw
	diEffect.dwTriggerRepeatInterval = 0;
	diEffect.cAxes = 2; 	// ͂Q{
	diEffect.rgdwAxes = dwAxes; 	// GtFNgɊ֘A鎲ݒ
	diEffect.rglDirection = lDirection;	// GtFNg̕ݒ
	diEffect.lpEnvelope = &diEnvelope;	// Gx[uݒ

	diEffect.cbTypeSpecificParams = sizeof(diPeriodic);
	diEffect.lpvTypeSpecificParams = &diPeriodic;  

	hr = g_pDIDevice->CreateEffect(GUID_Triangle,
						&diEffect,		// GtFNgɂĐݒ肵\
						&g_pDIEffect,	// GtFNgEIuWFNg󂯎|C^̃|C^
						NULL);		// ŴȂ
	if (FAILED(hr))
	{
		DXTRACE_ERR("GtFNg𐶐ł܂", hr);
		return false;
	}

	return true;
}

// WCXeBbN񋓂֐
BOOL CALLBACK EnumJoysticksCallback(const DIDEVICEINSTANCE* pdidInstance, VOID* pContext)
{
	HRESULT hr;

	// 񋓂ꂽWCXeBbNւ̃C^[tFCX擾B
	hr = g_pDInput->CreateDevice(pdidInstance->guidInstance, &g_pDIDevice, NULL);
	if (FAILED(hr)) 
		return DIENUM_CONTINUE;

	// WCXeBbN̔\͂𒲂ׂ
	g_diDevCaps.dwSize = sizeof(DIDEVCAPS);
	hr = g_pDIDevice->GetCapabilities(&g_diDevCaps);
	if (FAILED(hr))
	{
		// WCXeBbN\͂̎擾Ɏs
		RELEASE(g_pDIDevice);
		return DIENUM_CONTINUE;
	}

	return DIENUM_STOP;
}

// WCXeBbN̎񋓂֐
BOOL CALLBACK EnumAxesCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi, LPVOID pvRef)
{
	HRESULT hr;

	// ̒l͈̔͂ݒi-1000`1000j
	DIPROPRANGE diprg;
	ZeroMemory(&diprg, sizeof(diprg));
	diprg.diph.dwSize	= sizeof(diprg); 
	diprg.diph.dwHeaderSize	= sizeof(diprg.diph); 
	diprg.diph.dwObj	= lpddoi->dwType;
	diprg.diph.dwHow	= DIPH_BYID;
	diprg.lMin	= -1000;
	diprg.lMax	= +1000;
	hr = g_pDIDevice->SetProperty(DIPROP_RANGE, &diprg.diph);
	if (FAILED(hr))
		return DIENUM_STOP;

	return DIENUM_CONTINUE;
}

/*-------------------------------------------
	DirectInput̉
--------------------------------------------*/
bool ReleaseDInput(void)
{
	// GtFNgfoCXA[h
	if(g_pDIEffect)
		g_pDIEffect->Unload();

	// DirectInput̃foCX
	RELEASE(g_pDIEffect);
	if (g_pDIDevice)
		g_pDIDevice->Unacquire(); 
	RELEASE(g_pDIDevice);
	RELEASE(g_pDInput);

	return true;
}

/*-------------------------------------------
	Ȉ
--------------------------------------------*/
bool EndApp(void)
{
	return true;
}

/*-------------------------------------------
	L[͏
--------------------------------------------*/
void WM_KeyDown(HWND hWnd, UINT wParam)
{
	switch(wParam){
		// EChE
		case VK_ESCAPE:
		case VK_F12:
			DestroyWindow(hWnd);
			return;
	}
}

/*-------------------------------------------
	^C}[
--------------------------------------------*/
void WM_Timer(HWND hWnd, WPARAM wParam)
{
	// ʍXV
	InvalidateRect(hWnd, NULL, TRUE);
}

/*-------------------------------------------
	EChE̕`揈
--------------------------------------------*/
void WM_Paint(HWND hWnd)
{
	PAINTSTRUCT ps;
	HDC hDC = BeginPaint(hWnd, &ps);

	if (g_pDIDevice!=NULL)
	{
		HRESULT hr;
		char CData[1024];
		int y = 0;

		// foCX̒ڃf[^擾
		hr = g_pDIDevice->Poll();
		if (FAILED(hr))
		{
			hr = g_pDIDevice->Acquire();
			while (g_bActive && hr==DIERR_INPUTLOST)
				hr = g_pDIDevice->Acquire();
		}

		DIJOYSTATE2 dijs;
		hr = g_pDIDevice->GetDeviceState(sizeof(DIJOYSTATE2), &dijs);
		if (SUCCEEDED(hr))
		{
			// \
			wsprintf(CData,"[X=%d Y=%d Z=%d][Rx=%d Ry=%d Rz=%d][Slider1=%d Slider2=%d]",
					dijs.lX,dijs.lY,dijs.lZ,
					dijs.lRx,dijs.lRy,dijs.lRz,
					dijs.rglSlider[0],dijs.rglSlider[1]);
			TextOut(hDC, 0, y, CData, lstrlen(CData));
			y += 20;

			// {^\
			int d = 0;
			for(int i=0; i<9; i++)
			{
				if(dijs.rgbButtons[i] & 0x80)
					d += wsprintf(CData + d,"[%d]",i);
				else
					d += wsprintf(CData + d,"[-]");
			}
			CData[d] = 0;

			TextOut(hDC, 0, y, CData, lstrlen(CData));
			y += 20;
		}
		else if (g_bActive && hr==DIERR_INPUTLOST)
			g_pDIDevice->Acquire();
		y += 40;

		// obt@OEf[^擾
		while(g_bActive)
		{
			DIDEVICEOBJECTDATA od;
			DWORD dwItems = 1;
			hr = g_pDIDevice->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),
								&od, &dwItems, 0);
			if (hr==DIERR_INPUTLOST)
				g_pDIDevice->Acquire();
			else if (FAILED(hr) || dwItems == 0)
	            break;	// f[^ǂ߂ȂA݂Ȃ
			else
			{
				switch (od.dwOfs) 
				{
				case DIJOFS_X:
					wsprintf(CData, "[%lu] DIJOFS_X = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_Y:
					wsprintf(CData, "[%lu] DIJOFS_Y = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_Z:
					wsprintf(CData, "[%lu] DIJOFS_Z = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_RX:
					wsprintf(CData, "[%lu] DIJOFS_Rx = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_RY:
					wsprintf(CData, "[%lu] DIJOFS_Ry = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_RZ:
					wsprintf(CData, "[%lu] DIJOFS_Rz = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON0:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON0 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON1:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON1 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON2:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON2 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON3:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON3 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON4:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON4 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON5:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON5 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON6:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON6 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON7:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON7 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_BUTTON8:
					wsprintf(CData, "[%lu] DIJOFS_BUTTON8 = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_SLIDER(0):
					wsprintf(CData, "[%lu] DIJOFS_SLIDER(0) = %d", od.dwSequence, od.dwData); break;
				case DIJOFS_SLIDER(1):
					wsprintf(CData, "[%lu] DIJOFS_SLIDER(1) = %d", od.dwSequence, od.dwData); break;
				default: 
					wsprintf(CData, "[%lu] %ld = %d", od.dwSequence, od.dwOfs, od.dwData); break;
				}
				TextOut(hDC, 0, y, CData, lstrlen(CData));
				y += 20;
			}
		}
	}

	EndPaint(hWnd, &ps);
}

/*-------------------------------------------
	EChE
--------------------------------------------*/
LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,UINT wParam,LONG lParam)
{
	switch(msg)
	{
		case WM_ACTIVATE:		// EChẼANeBuԂω
			if(g_pDIDevice == NULL)
				break;
			g_bActive = wParam != WA_INACTIVE;
			if(wParam == WA_INACTIVE)
				g_pDIDevice->Unacquire();
			else
				g_pDIDevice->Acquire();
			break;
		case WM_KEYDOWN:	// L[ꂽ
			WM_KeyDown(hWnd, wParam);
			break;
		case WM_CREATE:		// EChEꂽ
			SetTimer(hWnd, 1, 100, NULL);
			break;
		case WM_DESTROY:	// EChEj
			KillTimer(hWnd, 1);
			PostQuitMessage(0);
			break;
		case WM_TIMER:		// ^C}[ECxg
			WM_Timer(hWnd, wParam);
			break;
		case WM_PAINT:		// ʕ`
			WM_Paint(hWnd);
			break;
		default:			// ̑̃bZ[W
			return DefWindowProc(hWnd,msg,wParam,lParam);
	}
	return 0L;
}

/*--------------------------------------------
	bZ[WȂƂ̏
---------------------------------------------*/
bool AppIdle()
{
	return true;	// falseԂƃbZ[W܂őҋ@
}

/*--------------------------------------------
	C
---------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInst,HINSTANCE /*hPrevInst*/,LPSTR /*lpCmdLine*/,int nCmdShow)
{
	bool flag = false;
	// AvP[VɊւ鏉
	if (InitApp(hInst,nCmdShow))
	{
		// DirectInputɊւ鏉
		flag = InitDInput();
	}

	// bZ[WE[v
	MSG msg;
	msg.wParam = -1;
	while (flag)
	{
		while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if (msg.message == WM_QUIT)
			{
				flag = false;
				break;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (AppIdle()==false)
			PostQuitMessage(0);
	}


	// DirectInput̏I
	ReleaseDInput();

	// AvP[V̏I
	EndApp();

	return msg.wParam;
}
